//
//  ODDocument.m
//  OvalDoc
//
//  Created by narita on 2013/10/05.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "ODDocument.h"
#import "ODOvalView.h"

@implementation ODDocument

- (id)init
{
    self = [super init];
    
    if (self)
    {
        // Add your subclass-specific initialization here.
    }
    
    return self;
}

- (void)windowWillClose:(NSNotification *)notification;
{
    [self unbind:@"oval"];
    [self.ovalView unbind:@"oval"];
    
    self.controller = nil;
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"ODDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *)aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
    
    self.ovalView.oval = self.oval;

    [self.ovalView bind:@"oval"
               toObject:self.controller
            withKeyPath:@"selection.oval"
                options:nil];
}

+ (BOOL)autosavesInPlace
{
    return YES;
}

- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError
{
    return [NSKeyedArchiver archivedDataWithRootObject:[NSValue valueWithRect:self.oval]];
}

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError
{
    NSValue* theNewOvalValue = nil;
    
    @try
    {
        theNewOvalValue = [NSKeyedUnarchiver unarchiveObjectWithData:data];
    }
    @catch (NSException *exception)
    {
        if(outError)
        {
            NSDictionary* theDict = [NSDictionary dictionaryWithObject:@"the data is corrupted."
                                                                forKey:NSLocalizedFailureReasonErrorKey];
            
            *outError = [NSError errorWithDomain:NSOSStatusErrorDomain
                                            code:unimpErr userInfo:theDict];
        }
        
        return NO;
    }
    @finally
    {
        
    }
    
    
    _oval = [theNewOvalValue rectValue];
    
    return YES;
}

#pragma mark Accessors

@synthesize oval = _oval;

- (NSRect) oval
{
    return _oval;
}

- (void) setOval:(NSRect)inOval
{
    if( !NSEqualRects(_oval, inOval) )
    {
        NSRect theOldOval = _oval;
        
        _oval = inOval;
                
        {
            NSUndoManager* theUndoMgr  = [self undoManager];
            ODDocument*    theInstance = [theUndoMgr prepareWithInvocationTarget:self];
            
            [theUndoMgr setActionName:@"change Oval"];
            
            [theInstance setOval:theOldOval];
        }
    }
}

@end
